unit MyWebTestMain;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Sphinx.WebLogin, Vcl.Controls, Vcl.StdCtrls,
  WEBLib.StdCtrls, Sphinx.LoginCommon;

type
  TMyWebTestMainForm = class(TWebForm)
    WebButton1: TWebButton;
    SphinxWebLogin1: TSphinxWebLogin;
    WebMemo1: TWebMemo;
    procedure WebFormCreate(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
  private
    FToken : string;
  public
    procedure MyUserLoggedInProc(Args: TUserLoggedInArgs);
  end;

var
  MyWebTestMainForm: TMyWebTestMainForm;

implementation

{$R *.dfm}

procedure TMyWebTestMainForm.WebFormCreate(Sender: TObject);
begin
  WebMemo1.Clear;
  WebButton1.Caption := 'Connection';

  SphinxWebLogin1.OnUserLoggedIn := MyUserLoggedInProc;
  SphinxWebLogin1.Authority := 'http://localhost:2001/tms/sphinx';
  SphinxWebLogin1.ClientId := 'mywebtest';
  SphinxWebLogin1.Scope := 'openid email';
  SphinxWebLogin1.RedirectUri := 'http://localhost:8000/MyWebTest/MyWebTest.html';
end;

procedure TMyWebTestMainForm.MyUserLoggedInProc(Args: TUserLoggedInArgs);
begin
  ShowMessage('MyUserLoggedInProc');  // To verify procedure execution
  FToken := Args.LoginResult.AccessToken;
  WebMemo1.Lines.Add('Token: ' + Args.LoginResult.AccessToken);
  if Args.LoginResult.Profile <> nil then
  begin
    WebMemo1.Lines.Add('Name: ' + Args.LoginResult.Profile.Name);
    WebMemo1.Lines.Add('Profile: ' + Args.LoginResult.Profile.Profile);
    WebMemo1.Lines.Add('Email: ' + Args.LoginResult.Profile.Email);
  end;

  WebButton1.Caption := 'Logoff';
end;

procedure TMyWebTestMainForm.WebButton1Click(Sender: TObject);
begin
  if not SphinxWebLogin1.IsLoggedIn then
  begin
    ShowMessage('Click OK to connect');  // To verify procedure execution
    SphinxWebLogin1.Login;
  end else
  begin
    MessageDlg('Already connected. Do you like to disconnect?', mtConfirmation, [mbYes, mbNo],
        procedure (AValue: TModalResult)
        begin
          if AValue = mrYes then
          begin
            SphinxWebLogin1.Logout;
            WebMemo1.Lines.Add('*************LOGOFF*************');
            WebButton1.Caption := 'Click to connect';
          end;
        end);
  end;
end;

end.
